// some circuits added by aurelien.esnard@u-bordeaux.fr for MY CPU

/* ========= HEXA CONSTANTS ========= */

var hexconst0 = 
{
  "width":600,
  "height":300,
  "showToolbox":false,
  "devices":[
    {"type":"BusOut","id":"dev0","x":160,"y":88,"label":"BusOut"},
    {"type":"Out","id":"dev1","x":224,"y":96,"label":""},
    {"type":"4bit7segBus","id":"dev2","x":296,"y":80,"label":"4bit7segBus"},
    {"type":"DC","id":"dev3","x":64,"y":96,"label":"DC"}
  ],
  "connectors":[
    {"from":"dev1.in0","to":"dev0.out0"},
    {"from":"dev2.in0","to":"dev1.out0"}
  ]
};

var c1 = {"from":"dev0.in0","to":"dev3.out0"};
var c2 = {"from":"dev0.in1","to":"dev3.out0"};
var c4 = {"from":"dev0.in2","to":"dev3.out0"};
var c8 = {"from":"dev0.in3","to":"dev3.out0"};

var hexconst1 = jQuery.extend(true, {}, hexconst0); 
var hexconst2 = jQuery.extend(true, {}, hexconst0);
var hexconst3 = jQuery.extend(true, {}, hexconst0);
var hexconst4 = jQuery.extend(true, {}, hexconst0);
var hexconst5 = jQuery.extend(true, {}, hexconst0);
var hexconst6 = jQuery.extend(true, {}, hexconst0);
var hexconst7 = jQuery.extend(true, {}, hexconst0);
var hexconst8 = jQuery.extend(true, {}, hexconst0);
var hexconst9 = jQuery.extend(true, {}, hexconst0);
var hexconstA = jQuery.extend(true, {}, hexconst0);
var hexconstB = jQuery.extend(true, {}, hexconst0);
var hexconstC = jQuery.extend(true, {}, hexconst0);
var hexconstD = jQuery.extend(true, {}, hexconst0);
var hexconstE = jQuery.extend(true, {}, hexconst0);
var hexconstF = jQuery.extend(true, {}, hexconst0);

hexconst1["connectors"].push(c1);
hexconst2["connectors"].push(c2);
hexconst3["connectors"].push(c1,c2);
hexconst4["connectors"].push(c4);
hexconst5["connectors"].push(c1,c4);
hexconst6["connectors"].push(c2,c4);
hexconst7["connectors"].push(c1,c2,c4);
hexconst8["connectors"].push(c8);
hexconst9["connectors"].push(c1,c8);
hexconstA["connectors"].push(c2,c8);
hexconstB["connectors"].push(c1,c2,c8);
hexconstC["connectors"].push(c4,c8);
hexconstD["connectors"].push(c1,c4,c8);
hexconstE["connectors"].push(c2,c4,c8);
hexconstF["connectors"].push(c1,c2,c4,c8);

simcir.registerDevice('0x0', hexconst0);
simcir.registerDevice('0x1', hexconst1);
simcir.registerDevice('0x2', hexconst2);
simcir.registerDevice('0x3', hexconst3);
simcir.registerDevice('0x4', hexconst4);
simcir.registerDevice('0x5', hexconst5);
simcir.registerDevice('0x6', hexconst6);
simcir.registerDevice('0x7', hexconst7);
simcir.registerDevice('0x8', hexconst8);
simcir.registerDevice('0x9', hexconst9);
simcir.registerDevice('0xA', hexconstA);
simcir.registerDevice('0xB', hexconstB);
simcir.registerDevice('0xC', hexconstC);
simcir.registerDevice('0xD', hexconstD);
simcir.registerDevice('0xE', hexconstE);
simcir.registerDevice('0xF', hexconstF);

/* ========= 4-Bits Register with Enable/Reset  ========= */

// Register with both Enable and Reset
simcir.registerDevice('RegBus-ER',
{
  "width":1000,
  "height":800,
  "showToolbox":false,
  "devices":[
    {"type":"4<4","id":"dev0","x":264,"y":384,"label":""},
    {"type":"4>4","id":"dev1","x":264,"y":288,"label":""},
    {"type":"Out","id":"dev2","x":696,"y":392,"label":"Q"},
    {"type":"In","id":"dev3","x":168,"y":360,"label":"E"},
    {"type":"MuxBus2","id":"dev4","x":320,"y":368,"label":"MuxBus2"},
    {"type":"AndBus1","id":"dev5","x":464,"y":384,"label":"AndBus1"},
    {"type":"DC","id":"dev6","x":104,"y":360,"label":"DC"},
    {"type":"In","id":"dev7","x":160,"y":472,"label":"D"},
    {"type":"DC","id":"dev8","x":16,"y":472,"label":"DC"},
    {"type":"RotaryEncoderBus","id":"dev9","x":72,"y":456,"label":"RotaryEncoderBus"},
    {"type":"4bit7segBus","id":"dev10","x":136,"y":568,"label":"4bit7segBus"},
    {"type":"4>4","id":"dev11","x":648,"y":288,"label":""},
    {"type":"DC","id":"dev12","x":272,"y":472,"label":"DC"},
    {"type":"DC","id":"dev13","x":272,"y":536,"label":"DC"},
    {"type":"NOT","id":"dev14","x":416,"y":432,"label":"NOT"},
    {"type":"4bit7segBus","id":"dev15","x":560,"y":312,"label":"4bit7segBus"},
    {"type":"Toggle","id":"dev16","x":136,"y":360,"label":"Toggle"},
    {"type":"4bit7segBus","id":"dev17","x":776,"y":376,"label":"4bit7segBus"},
    {"type":"RegBus","id":"dev18","x":600,"y":392,"label":"RegBus"},
    {"type":"Toggle","id":"dev19","x":304,"y":472,"label":"Toggle"},
    {"type":"In","id":"dev20","x":336,"y":472,"label":"RST"},
    {"type":"PushOn","id":"dev21","x":304,"y":536,"label":"PushOn"},
    {"type":"In","id":"dev22","x":336,"y":536,"label":"CLK"}
  ],
  "connectors":[
    {"from":"dev0.in0","to":"dev1.out0"},
    {"from":"dev1.in0","to":"dev11.out0"},
    {"from":"dev2.in0","to":"dev18.out0"},
    {"from":"dev3.in0","to":"dev16.out0"},
    {"from":"dev4.in0","to":"dev3.out0"},
    {"from":"dev4.in1","to":"dev0.out0"},
    {"from":"dev4.in2","to":"dev7.out0"},
    {"from":"dev5.in0","to":"dev4.out0"},
    {"from":"dev5.in1","to":"dev14.out0"},
    {"from":"dev7.in0","to":"dev9.out0"},
    {"from":"dev9.in0","to":"dev8.out0"},
    {"from":"dev10.in0","to":"dev9.out0"},
    {"from":"dev11.in0","to":"dev18.out0"},
    {"from":"dev14.in0","to":"dev20.out0"},
    {"from":"dev15.in0","to":"dev5.out0"},
    {"from":"dev16.in0","to":"dev6.out0"},
    {"from":"dev17.in0","to":"dev2.out0"},
    {"from":"dev18.in0","to":"dev5.out0"},
    {"from":"dev18.in1","to":"dev22.out0"},
    {"from":"dev19.in0","to":"dev12.out0"},
    {"from":"dev20.in0","to":"dev19.out0"},
    {"from":"dev21.in0","to":"dev13.out0"},
    {"from":"dev22.in0","to":"dev21.out0"}
  ]
}
    		      
);

/* ========= AndBus  ========= */

simcir.registerDevice('AndBus',  
{
  "width":600,
  "height":400,
  "showToolbox":false,
  "devices":[
    {"type":"BusIn","id":"dev0","x":144,"y":216,"label":"BusIn"},
    {"type":"BusIn","id":"dev1","x":144,"y":136,"label":"BusIn"},
    {"type":"BusOut","id":"dev2","x":376,"y":152,"label":"BusOut"},
    {"type":"In","id":"dev3","x":64,"y":144,"label":"In"},
    {"type":"In","id":"dev4","x":64,"y":224,"label":"In"},
    {"type":"Out","id":"dev5","x":472,"y":160,"label":"Out"},
    {"type":"AND","id":"dev6","x":256,"y":192,"label":"AND"},
    {"type":"AND","id":"dev7","x":256,"y":272,"label":"AND"},
    {"type":"AND","id":"dev8","x":256,"y":120,"label":"AND"},
    {"type":"AND","id":"dev9","x":256,"y":48,"label":"AND"}
  ],
  "connectors":[
    {"from":"dev0.in0","to":"dev4.out0"},
    {"from":"dev1.in0","to":"dev3.out0"},
    {"from":"dev2.in0","to":"dev9.out0"},
    {"from":"dev2.in1","to":"dev8.out0"},
    {"from":"dev2.in2","to":"dev6.out0"},
    {"from":"dev2.in3","to":"dev7.out0"},
    {"from":"dev5.in0","to":"dev2.out0"},
    {"from":"dev6.in0","to":"dev1.out2"},
    {"from":"dev6.in1","to":"dev0.out2"},
    {"from":"dev7.in0","to":"dev1.out3"},
    {"from":"dev7.in1","to":"dev0.out3"},
    {"from":"dev8.in0","to":"dev1.out1"},
    {"from":"dev8.in1","to":"dev0.out1"},
    {"from":"dev9.in0","to":"dev1.out0"},
    {"from":"dev9.in1","to":"dev0.out0"}
  ]
}

);

/* ========= MuxBus4  ========= */

simcir.registerDevice('MuxBus4',  
{
  "width":1200,
  "height":1600,
  "showToolbox":false,
  "devices":[
    {"type":"DC","id":"dev0","x":64,"y":72,"label":"DC"},
    {"type":"In","id":"dev1","x":208,"y":72,"label":"Sel"},
    {"type":"In","id":"dev2","x":232,"y":296,"label":"D0"},
    {"type":"In","id":"dev3","x":232,"y":344,"label":"D1"},
    {"type":"In","id":"dev4","x":232,"y":392,"label":"D2"},
    {"type":"In","id":"dev5","x":232,"y":440,"label":"D3"},
    {"type":"In","id":"dev6","x":232,"y":528,"label":"D4"},
    {"type":"In","id":"dev7","x":232,"y":576,"label":"D5"},
    {"type":"In","id":"dev8","x":232,"y":624,"label":"D6"},
    {"type":"In","id":"dev9","x":232,"y":672,"label":"D7"},
    {"type":"In","id":"dev10","x":232,"y":744,"label":"D8"},
    {"type":"In","id":"dev11","x":232,"y":792,"label":"D9"},
    {"type":"In","id":"dev12","x":232,"y":840,"label":"DA"},
    {"type":"MuxBus","id":"dev13","x":552,"y":568,"label":"MuxBus"},
    {"type":"In","id":"dev14","x":232,"y":888,"label":"DB"},
    {"type":"In","id":"dev15","x":240,"y":1056,"label":"DC"},
    {"type":"In","id":"dev16","x":240,"y":1008,"label":"DD"},
    {"type":"In","id":"dev17","x":240,"y":1104,"label":"DE"},
    {"type":"In","id":"dev18","x":240,"y":1152,"label":"DF"},
    {"type":"MuxBus","id":"dev19","x":568,"y":1048,"label":"MuxBus"},
    {"type":"OrBus","id":"dev20","x":768,"y":696,"label":"OrBus"},
    {"type":"Out","id":"dev21","x":880,"y":696,"label":"S"},
    {"type":"RotaryEncoderBus","id":"dev22","x":112,"y":56,"label":"RotaryEncoderBus"},
    {"type":"4<4","id":"dev23","x":552,"y":720,"label":""},
    {"type":"4<4","id":"dev24","x":536,"y":496,"label":""},
    {"type":"4<4","id":"dev25","x":536,"y":264,"label":""},
    {"type":"OrBus","id":"dev26","x":680,"y":504,"label":"OrBus"},
    {"type":"OrBus","id":"dev27","x":672,"y":944,"label":"OrBus"},
    {"type":"4<4","id":"dev28","x":552,"y":976,"label":""},
    {"type":"4<4","id":"dev29","x":472,"y":264,"label":""},
    {"type":"4bit7segBus","id":"dev30","x":520,"y":80,"label":"4bit7segBus"},
    {"type":"BusOut","id":"dev31","x":440,"y":72,"label":"BusOut"},
    {"type":"4<4","id":"dev32","x":472,"y":496,"label":""},
    {"type":"4<4","id":"dev33","x":472,"y":976,"label":""},
    {"type":"4<4","id":"dev34","x":472,"y":720,"label":""},
    {"type":"2to4Decoder","id":"dev35","x":104,"y":184,"label":"2to4Decoder"},
    {"type":"MuxBus","id":"dev36","x":552,"y":344,"label":"MuxBus"},
    {"type":"AndBus1","id":"dev37","x":312,"y":304,"label":"AndBus1"},
    {"type":"AndBus1","id":"dev38","x":312,"y":352,"label":"AndBus1"},
    {"type":"AndBus1","id":"dev39","x":312,"y":400,"label":"AndBus1"},
    {"type":"AndBus1","id":"dev40","x":312,"y":448,"label":"AndBus1"},
    {"type":"4bit7segBus","id":"dev41","x":272,"y":8,"label":"4bit7segBus"},
    {"type":"DC","id":"dev42","x":48,"y":216,"label":"DC"},
    {"type":"MuxBus","id":"dev43","x":568,"y":784,"label":"MuxBus"},
    {"type":"AndBus1","id":"dev44","x":312,"y":1112,"label":"AndBus1"},
    {"type":"AndBus1","id":"dev45","x":312,"y":680,"label":"AndBus1"},
    {"type":"AndBus1","id":"dev46","x":312,"y":632,"label":"AndBus1"},
    {"type":"AndBus1","id":"dev47","x":312,"y":752,"label":"AndBus1"},
    {"type":"AndBus1","id":"dev48","x":312,"y":800,"label":"AndBus1"},
    {"type":"AndBus1","id":"dev49","x":312,"y":848,"label":"AndBus1"},
    {"type":"AndBus1","id":"dev50","x":312,"y":896,"label":"AndBus1"},
    {"type":"AndBus1","id":"dev51","x":312,"y":584,"label":"AndBus1"},
    {"type":"AndBus1","id":"dev52","x":312,"y":536,"label":"AndBus1"},
    {"type":"AndBus1","id":"dev53","x":312,"y":1160,"label":"AndBus1"},
    {"type":"AndBus1","id":"dev54","x":312,"y":1064,"label":"AndBus1"},
    {"type":"AndBus1","id":"dev55","x":312,"y":1016,"label":"AndBus1"},
    {"type":"pinleft","id":"dev56","x":64,"y":192,"label":""},
    {"type":"pinleft","id":"dev57","x":400,"y":160,"label":""},
    {"type":"pinright","id":"dev58","x":64,"y":160,"label":""},
    {"type":"pinleft","id":"dev59","x":400,"y":208,"label":""},
    {"type":"pinleft","id":"dev60","x":240,"y":496,"label":""},
    {"type":"pinleft","id":"dev61","x":232,"y":256,"label":""},
    {"type":"pinleft","id":"dev62","x":248,"y":976,"label":""},
    {"type":"pinleft","id":"dev63","x":240,"y":720,"label":""},
    {"type":"pinleft","id":"dev64","x":168,"y":976,"label":""},
    {"type":"pinleft","id":"dev65","x":184,"y":720,"label":""},
    {"type":"BusIn","id":"dev66","x":368,"y":72,"label":"BusIn"},
    {"type":"0x0","id":"dev67","x":72,"y":296,"label":"0x0"},
    {"type":"0x1","id":"dev68","x":72,"y":344,"label":"0x1"},
    {"type":"0x2","id":"dev69","x":72,"y":392,"label":"0x2"},
    {"type":"0x3","id":"dev70","x":72,"y":440,"label":"0x3"},
    {"type":"0x5","id":"dev71","x":72,"y":576,"label":"0x5"},
    {"type":"0x6","id":"dev72","x":72,"y":624,"label":"0x6"},
    {"type":"0x7","id":"dev73","x":72,"y":672,"label":"0x7"},
    {"type":"0x4","id":"dev74","x":72,"y":528,"label":"0x4"},
    {"type":"0x8","id":"dev75","x":72,"y":744,"label":"0x8"},
    {"type":"0x9","id":"dev76","x":72,"y":792,"label":"0x9"},
    {"type":"0xA","id":"dev77","x":72,"y":840,"label":"0xA"},
    {"type":"0xB","id":"dev78","x":72,"y":888,"label":"0xB"},
    {"type":"0xF","id":"dev79","x":80,"y":1152,"label":"0xF"},
    {"type":"0xE","id":"dev80","x":80,"y":1104,"label":"0xE"},
    {"type":"0xD","id":"dev81","x":80,"y":1056,"label":"0xD"},
    {"type":"0xC","id":"dev82","x":80,"y":1008,"label":"0xC"},
    {"type":"4bit7segBus","id":"dev83","x":912,"y":296,"label":"4bit7segBus"}
  ],
  "connectors":[
    {"from":"dev1.in0","to":"dev22.out0"},
    {"from":"dev2.in0","to":"dev67.out0"},
    {"from":"dev3.in0","to":"dev68.out0"},
    {"from":"dev4.in0","to":"dev69.out0"},
    {"from":"dev5.in0","to":"dev70.out0"},
    {"from":"dev6.in0","to":"dev74.out0"},
    {"from":"dev7.in0","to":"dev71.out0"},
    {"from":"dev8.in0","to":"dev72.out0"},
    {"from":"dev9.in0","to":"dev73.out0"},
    {"from":"dev10.in0","to":"dev75.out0"},
    {"from":"dev11.in0","to":"dev76.out0"},
    {"from":"dev12.in0","to":"dev77.out0"},
    {"from":"dev13.in0","to":"dev24.out0"},
    {"from":"dev13.in1","to":"dev52.out0"},
    {"from":"dev13.in2","to":"dev51.out0"},
    {"from":"dev13.in3","to":"dev46.out0"},
    {"from":"dev13.in4","to":"dev45.out0"},
    {"from":"dev14.in0","to":"dev78.out0"},
    {"from":"dev15.in0","to":"dev81.out0"},
    {"from":"dev16.in0","to":"dev82.out0"},
    {"from":"dev17.in0","to":"dev80.out0"},
    {"from":"dev18.in0","to":"dev79.out0"},
    {"from":"dev19.in0","to":"dev28.out0"},
    {"from":"dev19.in1","to":"dev55.out0"},
    {"from":"dev19.in2","to":"dev54.out0"},
    {"from":"dev19.in3","to":"dev44.out0"},
    {"from":"dev19.in4","to":"dev53.out0"},
    {"from":"dev20.in0","to":"dev26.out0"},
    {"from":"dev20.in1","to":"dev27.out0"},
    {"from":"dev21.in0","to":"dev20.out0"},
    {"from":"dev22.in0","to":"dev0.out0"},
    {"from":"dev23.in0","to":"dev34.out0"},
    {"from":"dev24.in0","to":"dev32.out0"},
    {"from":"dev25.in0","to":"dev29.out0"},
    {"from":"dev26.in0","to":"dev36.out0"},
    {"from":"dev26.in1","to":"dev13.out0"},
    {"from":"dev27.in0","to":"dev43.out0"},
    {"from":"dev27.in1","to":"dev19.out0"},
    {"from":"dev28.in0","to":"dev33.out0"},
    {"from":"dev29.in0","to":"dev31.out0"},
    {"from":"dev30.in0","to":"dev31.out0"},
    {"from":"dev31.in0","to":"dev66.out0"},
    {"from":"dev31.in1","to":"dev66.out1"},
    {"from":"dev32.in0","to":"dev31.out0"},
    {"from":"dev33.in0","to":"dev31.out0"},
    {"from":"dev34.in0","to":"dev31.out0"},
    {"from":"dev35.in0","to":"dev56.out0"},
    {"from":"dev35.in1","to":"dev59.out0"},
    {"from":"dev35.in2","to":"dev42.out0"},
    {"from":"dev36.in0","to":"dev25.out0"},
    {"from":"dev36.in1","to":"dev37.out0"},
    {"from":"dev36.in2","to":"dev38.out0"},
    {"from":"dev36.in3","to":"dev39.out0"},
    {"from":"dev36.in4","to":"dev40.out0"},
    {"from":"dev37.in0","to":"dev2.out0"},
    {"from":"dev37.in1","to":"dev61.out0"},
    {"from":"dev38.in0","to":"dev3.out0"},
    {"from":"dev38.in1","to":"dev61.out0"},
    {"from":"dev39.in0","to":"dev4.out0"},
    {"from":"dev39.in1","to":"dev61.out0"},
    {"from":"dev40.in0","to":"dev5.out0"},
    {"from":"dev40.in1","to":"dev61.out0"},
    {"from":"dev41.in0","to":"dev1.out0"},
    {"from":"dev43.in0","to":"dev23.out0"},
    {"from":"dev43.in1","to":"dev47.out0"},
    {"from":"dev43.in2","to":"dev48.out0"},
    {"from":"dev43.in3","to":"dev49.out0"},
    {"from":"dev43.in4","to":"dev50.out0"},
    {"from":"dev44.in0","to":"dev17.out0"},
    {"from":"dev44.in1","to":"dev62.out0"},
    {"from":"dev45.in0","to":"dev9.out0"},
    {"from":"dev45.in1","to":"dev60.out0"},
    {"from":"dev46.in0","to":"dev8.out0"},
    {"from":"dev46.in1","to":"dev60.out0"},
    {"from":"dev47.in0","to":"dev10.out0"},
    {"from":"dev47.in1","to":"dev63.out0"},
    {"from":"dev48.in0","to":"dev11.out0"},
    {"from":"dev48.in1","to":"dev63.out0"},
    {"from":"dev49.in0","to":"dev12.out0"},
    {"from":"dev49.in1","to":"dev63.out0"},
    {"from":"dev50.in0","to":"dev14.out0"},
    {"from":"dev50.in1","to":"dev63.out0"},
    {"from":"dev51.in0","to":"dev7.out0"},
    {"from":"dev51.in1","to":"dev60.out0"},
    {"from":"dev52.in0","to":"dev6.out0"},
    {"from":"dev52.in1","to":"dev60.out0"},
    {"from":"dev53.in0","to":"dev18.out0"},
    {"from":"dev53.in1","to":"dev62.out0"},
    {"from":"dev54.in0","to":"dev15.out0"},
    {"from":"dev54.in1","to":"dev62.out0"},
    {"from":"dev55.in0","to":"dev16.out0"},
    {"from":"dev55.in1","to":"dev62.out0"},
    {"from":"dev56.in0","to":"dev58.out0"},
    {"from":"dev57.in0","to":"dev66.out2"},
    {"from":"dev58.in0","to":"dev57.out0"},
    {"from":"dev59.in0","to":"dev66.out3"},
    {"from":"dev60.in0","to":"dev35.out1"},
    {"from":"dev61.in0","to":"dev35.out0"},
    {"from":"dev62.in0","to":"dev64.out0"},
    {"from":"dev63.in0","to":"dev65.out0"},
    {"from":"dev64.in0","to":"dev35.out3"},
    {"from":"dev65.in0","to":"dev35.out2"},
    {"from":"dev66.in0","to":"dev1.out0"},
    {"from":"dev83.in0","to":"dev21.out0"}
  ]
}
);		      

/* ========= XorBus  ========= */

simcir.registerDevice('XorBus',
{
  "width":600,
  "height":400,
  "showToolbox":false,
  "devices":[
    {"type":"BusIn","id":"dev0","x":144,"y":216,"label":"BusIn"},
    {"type":"BusIn","id":"dev1","x":144,"y":136,"label":"BusIn"},
    {"type":"BusOut","id":"dev2","x":376,"y":152,"label":"BusOut"},
    {"type":"XOR","id":"dev3","x":264,"y":128,"label":"XOR"},
    {"type":"XOR","id":"dev4","x":264,"y":200,"label":"XOR"},
    {"type":"Out","id":"dev5","x":440,"y":160,"label":"Out"},
    {"type":"XOR","id":"dev6","x":264,"y":272,"label":"XOR"},
    {"type":"XOR","id":"dev7","x":264,"y":64,"label":"XOR"},
    {"type":"In","id":"dev8","x":64,"y":136,"label":"In"},
    {"type":"In","id":"dev9","x":64,"y":224,"label":"In"}
  ],
  "connectors":[
    {"from":"dev0.in0","to":"dev9.out0"},
    {"from":"dev1.in0","to":"dev8.out0"},
    {"from":"dev2.in0","to":"dev7.out0"},
    {"from":"dev2.in1","to":"dev3.out0"},
    {"from":"dev2.in2","to":"dev4.out0"},
    {"from":"dev2.in3","to":"dev6.out0"},
    {"from":"dev3.in0","to":"dev1.out1"},
    {"from":"dev3.in1","to":"dev0.out1"},
    {"from":"dev4.in0","to":"dev1.out2"},
    {"from":"dev4.in1","to":"dev0.out2"},
    {"from":"dev5.in0","to":"dev2.out0"},
    {"from":"dev6.in0","to":"dev1.out3"},
    {"from":"dev6.in1","to":"dev0.out3"},
    {"from":"dev7.in0","to":"dev1.out0"},
    {"from":"dev7.in1","to":"dev0.out0"}
  ]
}
);

/* ========= REGISTER FILE  ========= */

simcir.registerDevice('REGISTER FILE',  
{
  "width":1000,
  "height":600,
  "showToolbox":false,
  "devices":[
    {"type":"2to4DecoderBus","id":"dev0","x":320,"y":80,"label":"DecoderBus DST"},
    {"type":"4<4","id":"dev1","x":256,"y":104,"label":""},
    {"type":"4bit7segBus","id":"dev2","x":296,"y":216,"label":"4bit7segBus"},
    {"type":"DC","id":"dev3","x":72,"y":232,"label":"DC"},
    {"type":"RotaryEncoderBus","id":"dev4","x":128,"y":216,"label":"RB"},
    {"type":"4bit7segBus","id":"dev5","x":800,"y":280,"label":"4bit7segBus"},
    {"type":"4bit7segBus","id":"dev6","x":800,"y":392,"label":"4bit7segBus"},
    {"type":"Out","id":"dev7","x":736,"y":296,"label":"R2"},
    {"type":"Out","id":"dev8","x":736,"y":184,"label":"R1"},
    {"type":"Out","id":"dev9","x":736,"y":408,"label":"R3"},
    {"type":"RegBus-ER","id":"dev10","x":640,"y":392,"label":"RegBus-ER 3"},
    {"type":"RegBus-ER","id":"dev11","x":640,"y":280,"label":"RegBus-ER 2"},
    {"type":"pinleft","id":"dev12","x":472,"y":200,"label":""},
    {"type":"pinleft","id":"dev13","x":456,"y":480,"label":""},
    {"type":"pinleft","id":"dev14","x":472,"y":312,"label":""},
    {"type":"pinleft","id":"dev15","x":472,"y":424,"label":""},
    {"type":"pinleft","id":"dev16","x":512,"y":328,"label":""},
    {"type":"pinleft","id":"dev17","x":512,"y":216,"label":""},
    {"type":"pinleft","id":"dev18","x":512,"y":440,"label":""},
    {"type":"pinleft","id":"dev19","x":440,"y":184,"label":""},
    {"type":"pinleft","id":"dev20","x":440,"y":296,"label":""},
    {"type":"pinleft","id":"dev21","x":440,"y":408,"label":""},
    {"type":"pinleft","id":"dev22","x":496,"y":552,"label":""},
    {"type":"4<4","id":"dev23","x":560,"y":392,"label":""},
    {"type":"4<4","id":"dev24","x":560,"y":280,"label":""},
    {"type":"4<4","id":"dev25","x":560,"y":168,"label":""},
    {"type":"RegBus-ER","id":"dev26","x":640,"y":168,"label":"RegBus-ER 1"},
    {"type":"Toggle","id":"dev27","x":376,"y":472,"label":"Toggle"},
    {"type":"DC","id":"dev28","x":344,"y":472,"label":"DC"},
    {"type":"PushOn","id":"dev29","x":392,"y":544,"label":"PushOn"},
    {"type":"DC","id":"dev30","x":360,"y":544,"label":"DC"},
    {"type":"In","id":"dev31","x":408,"y":472,"label":"RST"},
    {"type":"In","id":"dev32","x":424,"y":544,"label":"CLK"},
    {"type":"In","id":"dev33","x":224,"y":232,"label":"DST"},
    {"type":"4bit7segBus","id":"dev34","x":800,"y":168,"label":"4bit7segBus"},
    {"type":"4<4","id":"dev35","x":544,"y":16,"label":""},
    {"type":"RotaryEncoderBus","id":"dev36","x":72,"y":352,"label":"RotaryEncoderBus"},
    {"type":"4bit7segBus","id":"dev37","x":256,"y":352,"label":"4bit7segBus"},
    {"type":"In","id":"dev38","x":176,"y":368,"label":"D"},
    {"type":"DC","id":"dev39","x":16,"y":368,"label":"DC"},
    {"type":"4<4","id":"dev40","x":208,"y":16,"label":""}
  ],
  "connectors":[
    {"from":"dev0.in0","to":"dev1.out0"},
    {"from":"dev1.in0","to":"dev33.out0"},
    {"from":"dev2.in0","to":"dev33.out0"},
    {"from":"dev4.in0","to":"dev3.out0"},
    {"from":"dev5.in0","to":"dev7.out0"},
    {"from":"dev6.in0","to":"dev9.out0"},
    {"from":"dev7.in0","to":"dev11.out0"},
    {"from":"dev8.in0","to":"dev26.out0"},
    {"from":"dev9.in0","to":"dev10.out0"},
    {"from":"dev10.in0","to":"dev23.out0"},
    {"from":"dev10.in1","to":"dev21.out0"},
    {"from":"dev10.in2","to":"dev15.out0"},
    {"from":"dev10.in3","to":"dev18.out0"},
    {"from":"dev11.in0","to":"dev24.out0"},
    {"from":"dev11.in1","to":"dev20.out0"},
    {"from":"dev11.in2","to":"dev14.out0"},
    {"from":"dev11.in3","to":"dev16.out0"},
    {"from":"dev12.in0","to":"dev13.out0"},
    {"from":"dev13.in0","to":"dev31.out0"},
    {"from":"dev14.in0","to":"dev13.out0"},
    {"from":"dev15.in0","to":"dev13.out0"},
    {"from":"dev16.in0","to":"dev22.out0"},
    {"from":"dev17.in0","to":"dev22.out0"},
    {"from":"dev18.in0","to":"dev22.out0"},
    {"from":"dev19.in0","to":"dev0.out1"},
    {"from":"dev20.in0","to":"dev0.out2"},
    {"from":"dev21.in0","to":"dev0.out3"},
    {"from":"dev22.in0","to":"dev32.out0"},
    {"from":"dev23.in0","to":"dev35.out0"},
    {"from":"dev24.in0","to":"dev35.out0"},
    {"from":"dev25.in0","to":"dev35.out0"},
    {"from":"dev26.in0","to":"dev25.out0"},
    {"from":"dev26.in1","to":"dev19.out0"},
    {"from":"dev26.in2","to":"dev12.out0"},
    {"from":"dev26.in3","to":"dev17.out0"},
    {"from":"dev27.in0","to":"dev28.out0"},
    {"from":"dev29.in0","to":"dev30.out0"},
    {"from":"dev31.in0","to":"dev27.out0"},
    {"from":"dev32.in0","to":"dev29.out0"},
    {"from":"dev33.in0","to":"dev4.out0"},
    {"from":"dev34.in0","to":"dev8.out0"},
    {"from":"dev35.in0","to":"dev40.out0"},
    {"from":"dev36.in0","to":"dev39.out0"},
    {"from":"dev37.in0","to":"dev38.out0"},
    {"from":"dev38.in0","to":"dev36.out0"},
    {"from":"dev40.in0","to":"dev38.out0"}
  ]
}
);

/* ========= NEWPC  ========= */

simcir.registerDevice('NEWPC',

{
  "width":1600,
  "height":1000,
  "showToolbox":false,
  "devices":[
    {"type":"In","id":"dev0","x":104,"y":576,"label":"RST"},
    {"type":"In","id":"dev1","x":104,"y":640,"label":"CLK"},
    {"type":"In","id":"dev2","x":600,"y":40,"label":"OP"},
    {"type":"In","id":"dev3","x":288,"y":40,"label":"VALC"},
    {"type":"DC","id":"dev4","x":440,"y":40,"label":"DC"},
    {"type":"RotaryEncoderBus","id":"dev5","x":496,"y":24,"label":"OP"},
    {"type":"4bit7segBus","id":"dev6","x":680,"y":24,"label":"4bit7segBus"},
    {"type":"DC","id":"dev7","x":128,"y":40,"label":"DC"},
    {"type":"Toggle","id":"dev8","x":72,"y":576,"label":"Toggle"},
    {"type":"DC","id":"dev9","x":40,"y":576,"label":"DC"},
    {"type":"PushOn","id":"dev10","x":72,"y":640,"label":"PushOn"},
    {"type":"DC","id":"dev11","x":40,"y":640,"label":"DC"},
    {"type":"RotaryEncoderBus","id":"dev12","x":176,"y":24,"label":"VALC"},
    {"type":"4bit7segBus","id":"dev13","x":360,"y":24,"label":"4bit7segBus"},
    {"type":"RegBus-ER","id":"dev14","x":248,"y":504,"label":"PC"},
    {"type":"Out","id":"dev15","x":368,"y":624,"label":"PC"},
    {"type":"4bit7segBus","id":"dev16","x":432,"y":608,"label":"4bit7segBus"},
    {"type":"4<4","id":"dev17","x":184,"y":504,"label":""},
    {"type":"DC","id":"dev18","x":88,"y":512,"label":"DC"},
    {"type":"MuxBus4","id":"dev19","x":632,"y":200,"label":"MuxBus4"},
    {"type":"4>4","id":"dev20","x":832,"y":144,"label":""},
    {"type":"4<4","id":"dev21","x":832,"y":328,"label":""},
    {"type":"4>4","id":"dev22","x":184,"y":152,"label":""},
    {"type":"IncBus","id":"dev23","x":392,"y":288,"label":"IncBus"},
    {"type":"4<4","id":"dev24","x":320,"y":352,"label":""}
  ],
  "connectors":[
    {"from":"dev0.in0","to":"dev8.out0"},
    {"from":"dev1.in0","to":"dev10.out0"},
    {"from":"dev2.in0","to":"dev5.out0"},
    {"from":"dev3.in0","to":"dev12.out0"},
    {"from":"dev5.in0","to":"dev4.out0"},
    {"from":"dev6.in0","to":"dev2.out0"},
    {"from":"dev8.in0","to":"dev9.out0"},
    {"from":"dev10.in0","to":"dev11.out0"},
    {"from":"dev12.in0","to":"dev7.out0"},
    {"from":"dev13.in0","to":"dev3.out0"},
    {"from":"dev14.in0","to":"dev17.out0"},
    {"from":"dev14.in1","to":"dev18.out0"},
    {"from":"dev14.in2","to":"dev0.out0"},
    {"from":"dev14.in3","to":"dev1.out0"},
    {"from":"dev15.in0","to":"dev14.out0"},
    {"from":"dev16.in0","to":"dev15.out0"},
    {"from":"dev17.in0","to":"dev22.out0"},
    {"from":"dev19.in0","to":"dev2.out0"},
    {"from":"dev19.in1","to":"dev23.out0"},
    {"from":"dev19.in2","to":"dev23.out0"},
    {"from":"dev19.in3","to":"dev23.out0"},
    {"from":"dev19.in4","to":"dev23.out0"},
    {"from":"dev19.in5","to":"dev23.out0"},
    {"from":"dev19.in6","to":"dev23.out0"},
    {"from":"dev19.in7","to":"dev23.out0"},
    {"from":"dev19.in8","to":"dev24.out0"},
    {"from":"dev19.in9","to":"dev24.out0"},
    {"from":"dev19.in10","to":"dev24.out0"},
    {"from":"dev19.in11","to":"dev23.out0"},
    {"from":"dev19.in12","to":"dev23.out0"},
    {"from":"dev19.in13","to":"dev23.out0"},
    {"from":"dev19.in14","to":"dev23.out0"},
    {"from":"dev19.in15","to":"dev23.out0"},
    {"from":"dev19.in16","to":"dev14.out0"},
    {"from":"dev20.in0","to":"dev21.out0"},
    {"from":"dev21.in0","to":"dev19.out0"},
    {"from":"dev22.in0","to":"dev20.out0"},
    {"from":"dev23.in0","to":"dev14.out0"},
    {"from":"dev24.in0","to":"dev3.out0"}
  ]
}

);


/* ========= ALU  ========= */

simcir.registerDevice('ALU',  
{
  "width":1200,
  "height":800,
  "showToolbox":false,
  "devices":[
    {"type":"DC","id":"dev0","x":40,"y":280,"label":"DC"},
    {"type":"DC","id":"dev1","x":40,"y":160,"label":"DC"},
    {"type":"DC","id":"dev2","x":40,"y":40,"label":"DC"},
    {"type":"RotaryEncoderBus","id":"dev3","x":96,"y":24,"label":"OP"},
    {"type":"DC","id":"dev4","x":40,"y":400,"label":"DC"},
    {"type":"RotaryEncoderBus","id":"dev5","x":96,"y":264,"label":"B"},
    {"type":"SubBus","id":"dev6","x":528,"y":264,"label":"SubBus"},
    {"type":"XorBus","id":"dev7","x":528,"y":392,"label":"XorBus"},
    {"type":"AddBus","id":"dev8","x":528,"y":192,"label":"AddBus"},
    {"type":"MuxBus4","id":"dev9","x":696,"y":176,"label":"MuxBus4"},
    {"type":"AndBus","id":"dev10","x":528,"y":336,"label":"AndBus"},
    {"type":"Out","id":"dev11","x":800,"y":296,"label":"E"},
    {"type":"RotaryEncoderBus","id":"dev12","x":96,"y":384,"label":"C"},
    {"type":"RotaryEncoderBus","id":"dev13","x":96,"y":144,"label":"A"},
    {"type":"In","id":"dev14","x":192,"y":280,"label":"B"},
    {"type":"In","id":"dev15","x":192,"y":400,"label":"C"},
    {"type":"In","id":"dev16","x":192,"y":160,"label":"A"},
    {"type":"4bit7segBus","id":"dev17","x":272,"y":384,"label":"4bit7segBus"},
    {"type":"4bit7segBus","id":"dev18","x":272,"y":264,"label":"4bit7segBus"},
    {"type":"4<4","id":"dev19","x":400,"y":408,"label":""},
    {"type":"4<4","id":"dev20","x":400,"y":288,"label":""},
    {"type":"4<4","id":"dev21","x":400,"y":168,"label":""},
    {"type":"In","id":"dev22","x":192,"y":40,"label":"OP"},
    {"type":"4bit7segBus","id":"dev23","x":272,"y":24,"label":"4bit7segBus"},
    {"type":"4bit7segBus","id":"dev24","x":272,"y":144,"label":"4bit7segBus"},
    {"type":"4bit7segBus","id":"dev25","x":872,"y":280,"label":"4bit7segBus"}
  ],
  "connectors":[
    {"from":"dev3.in0","to":"dev2.out0"},
    {"from":"dev5.in0","to":"dev0.out0"},
    {"from":"dev6.in0","to":"dev21.out0"},
    {"from":"dev6.in1","to":"dev20.out0"},
    {"from":"dev7.in0","to":"dev21.out0"},
    {"from":"dev7.in1","to":"dev20.out0"},
    {"from":"dev8.in0","to":"dev21.out0"},
    {"from":"dev8.in1","to":"dev20.out0"},
    {"from":"dev9.in0","to":"dev22.out0"},
    {"from":"dev9.in2","to":"dev8.out0"},
    {"from":"dev9.in3","to":"dev6.out0"},
    {"from":"dev9.in4","to":"dev10.out0"},
    {"from":"dev9.in5","to":"dev7.out0"},
    {"from":"dev9.in6","to":"dev19.out0"},
    {"from":"dev9.in7","to":"dev21.out0"},
    {"from":"dev10.in0","to":"dev21.out0"},
    {"from":"dev10.in1","to":"dev20.out0"},
    {"from":"dev11.in0","to":"dev9.out0"},
    {"from":"dev12.in0","to":"dev4.out0"},
    {"from":"dev13.in0","to":"dev1.out0"},
    {"from":"dev14.in0","to":"dev5.out0"},
    {"from":"dev15.in0","to":"dev12.out0"},
    {"from":"dev16.in0","to":"dev13.out0"},
    {"from":"dev17.in0","to":"dev15.out0"},
    {"from":"dev18.in0","to":"dev14.out0"},
    {"from":"dev19.in0","to":"dev15.out0"},
    {"from":"dev20.in0","to":"dev14.out0"},
    {"from":"dev21.in0","to":"dev16.out0"},
    {"from":"dev22.in0","to":"dev3.out0"},
    {"from":"dev23.in0","to":"dev22.out0"},
    {"from":"dev24.in0","to":"dev16.out0"},
    {"from":"dev25.in0","to":"dev11.out0"}
  ]
}

);

/* ========= My ROM  ========= */

simcir.registerDevice('ROM',  
{
  "width":1200,
  "height":800,
  "showToolbox":false,
  "devices":[
    {"type":"In","id":"dev0","x":336,"y":24,"label":"PC"},
    {"type":"RotaryEncoderBus","id":"dev1","x":232,"y":8,"label":"RotaryEncoderBus"},
    {"type":"DC","id":"dev2","x":168,"y":24,"label":"DC"},
    {"type":"0x0","id":"dev3","x":40,"y":192,"label":"0x0"},
    {"type":"0x0","id":"dev4","x":264,"y":192,"label":"0x0"},
    {"type":"0x0","id":"dev5","x":488,"y":192,"label":"0x0"},
    {"type":"0x0","id":"dev6","x":688,"y":192,"label":"0x0"},
    {"type":"4bit7segBus","id":"dev7","x":232,"y":560,"label":"4bit7segBus"},
    {"type":"Out","id":"dev8","x":200,"y":576,"label":"OP"},
    {"type":"4bit7segBus","id":"dev9","x":480,"y":560,"label":"4bit7segBus"},
    {"type":"Out","id":"dev10","x":448,"y":576,"label":"RA"},
    {"type":"4bit7segBus","id":"dev11","x":672,"y":560,"label":"4bit7segBus"},
    {"type":"Out","id":"dev12","x":640,"y":576,"label":"RB"},
    {"type":"0x5","id":"dev13","x":40,"y":240,"label":"0x5"},
    {"type":"0x5","id":"dev14","x":40,"y":288,"label":"0x5"},
    {"type":"0x6","id":"dev15","x":40,"y":336,"label":"0x6"},
    {"type":"0x1","id":"dev16","x":40,"y":384,"label":"0x1"},
    {"type":"0x0","id":"dev17","x":264,"y":240,"label":"0x0"},
    {"type":"0x0","id":"dev18","x":264,"y":288,"label":"0x0"},
    {"type":"0x2","id":"dev19","x":264,"y":336,"label":"0x2"},
    {"type":"0x1","id":"dev20","x":264,"y":384,"label":"0x1"},
    {"type":"0x1","id":"dev21","x":488,"y":240,"label":"0x1"},
    {"type":"0x2","id":"dev22","x":488,"y":288,"label":"0x2"},
    {"type":"0x3","id":"dev23","x":488,"y":336,"label":"0x3"},
    {"type":"0x3","id":"dev24","x":488,"y":384,"label":"0x3"},
    {"type":"0x6","id":"dev25","x":688,"y":240,"label":"0x6"},
    {"type":"0x4","id":"dev26","x":688,"y":288,"label":"0x4"},
    {"type":"0x0","id":"dev27","x":688,"y":336,"label":"0x0"},
    {"type":"0x0","id":"dev28","x":688,"y":384,"label":"0x0"},
    {"type":"MuxBus4","id":"dev29","x":136,"y":256,"label":"MuxBus4 OP"},
    {"type":"MuxBus4","id":"dev30","x":352,"y":256,"label":"MuxBus4 RA"},
    {"type":"MuxBus4","id":"dev31","x":576,"y":256,"label":"MuxBus4 RB"},
    {"type":"MuxBus4","id":"dev32","x":784,"y":256,"label":"MuxBus4 VALC"},
    {"type":"4bit7segBus","id":"dev33","x":880,"y":560,"label":"4bit7segBus"},
    {"type":"Out","id":"dev34","x":848,"y":576,"label":"VALC"},
    {"type":"4>4","id":"dev35","x":352,"y":120,"label":""},
    {"type":"4>4","id":"dev36","x":136,"y":120,"label":""},
    {"type":"4bit7segBus","id":"dev37","x":416,"y":8,"label":"4bit7segBus"},
    {"type":"4<4","id":"dev38","x":768,"y":120,"label":""},
    {"type":"4<4","id":"dev39","x":560,"y":120,"label":""},
    {"type":"0x7","id":"dev40","x":40,"y":432,"label":"0x7"},
    {"type":"0x0","id":"dev41","x":264,"y":432,"label":"0x0"},
    {"type":"0x0","id":"dev42","x":488,"y":432,"label":"0x0"},
    {"type":"0xF","id":"dev43","x":40,"y":480,"label":"0xF"},
    {"type":"0x1","id":"dev44","x":688,"y":432,"label":"0x1"},
    {"type":"0x0","id":"dev45","x":264,"y":480,"label":"0x0"},
    {"type":"0x0","id":"dev46","x":488,"y":480,"label":"0x0"},
    {"type":"0x0","id":"dev47","x":688,"y":480,"label":"0x0"}
  ],
  "connectors":[
    {"from":"dev0.in0","to":"dev1.out0"},
    {"from":"dev1.in0","to":"dev2.out0"},
    {"from":"dev7.in0","to":"dev8.out0"},
    {"from":"dev8.in0","to":"dev29.out0"},
    {"from":"dev9.in0","to":"dev10.out0"},
    {"from":"dev10.in0","to":"dev30.out0"},
    {"from":"dev11.in0","to":"dev12.out0"},
    {"from":"dev12.in0","to":"dev31.out0"},
    {"from":"dev29.in0","to":"dev36.out0"},
    {"from":"dev29.in1","to":"dev3.out0"},
    {"from":"dev29.in2","to":"dev13.out0"},
    {"from":"dev29.in3","to":"dev14.out0"},
    {"from":"dev29.in4","to":"dev15.out0"},
    {"from":"dev29.in5","to":"dev16.out0"},
    {"from":"dev29.in6","to":"dev40.out0"},
    {"from":"dev29.in7","to":"dev43.out0"},
    {"from":"dev30.in0","to":"dev35.out0"},
    {"from":"dev30.in1","to":"dev4.out0"},
    {"from":"dev30.in2","to":"dev17.out0"},
    {"from":"dev30.in3","to":"dev18.out0"},
    {"from":"dev30.in4","to":"dev19.out0"},
    {"from":"dev30.in5","to":"dev20.out0"},
    {"from":"dev30.in6","to":"dev41.out0"},
    {"from":"dev30.in7","to":"dev45.out0"},
    {"from":"dev31.in0","to":"dev39.out0"},
    {"from":"dev31.in1","to":"dev5.out0"},
    {"from":"dev31.in2","to":"dev21.out0"},
    {"from":"dev31.in3","to":"dev22.out0"},
    {"from":"dev31.in4","to":"dev23.out0"},
    {"from":"dev31.in5","to":"dev24.out0"},
    {"from":"dev31.in6","to":"dev42.out0"},
    {"from":"dev31.in7","to":"dev46.out0"},
    {"from":"dev32.in0","to":"dev38.out0"},
    {"from":"dev32.in1","to":"dev6.out0"},
    {"from":"dev32.in2","to":"dev25.out0"},
    {"from":"dev32.in3","to":"dev26.out0"},
    {"from":"dev32.in4","to":"dev27.out0"},
    {"from":"dev32.in5","to":"dev28.out0"},
    {"from":"dev32.in6","to":"dev44.out0"},
    {"from":"dev32.in7","to":"dev47.out0"},
    {"from":"dev33.in0","to":"dev34.out0"},
    {"from":"dev34.in0","to":"dev32.out0"},
    {"from":"dev35.in0","to":"dev0.out0"},
    {"from":"dev36.in0","to":"dev35.out0"},
    {"from":"dev37.in0","to":"dev0.out0"},
    {"from":"dev38.in0","to":"dev35.out0"},
    {"from":"dev39.in0","to":"dev35.out0"}
  ]
}
		      
);

/* ========= CPU  ========= */

simcir.registerDevice('CPU',

{
  "width":1600,
  "height":1000,
  "showToolbox":false,
  "devices":[
    {"type":"In","id":"dev0","x":88,"y":336,"label":"RST"},
    {"type":"In","id":"dev1","x":88,"y":400,"label":"CLK"},
    {"type":"In","id":"dev2","x":1104,"y":40,"label":"OP"},
    {"type":"In","id":"dev3","x":184,"y":40,"label":"RA"},
    {"type":"In","id":"dev4","x":480,"y":40,"label":"RB"},
    {"type":"In","id":"dev5","x":792,"y":40,"label":"VALC"},
    {"type":"MuxBus","id":"dev6","x":600,"y":240,"label":"MuxBus A"},
    {"type":"4bit7segBus","id":"dev7","x":552,"y":24,"label":"4bit7segBus"},
    {"type":"MuxBus","id":"dev8","x":600,"y":352,"label":"MuxBus B"},
    {"type":"RotaryEncoderBus","id":"dev9","x":80,"y":24,"label":"RA"},
    {"type":"DC","id":"dev10","x":328,"y":40,"label":"DC"},
    {"type":"DC","id":"dev11","x":32,"y":40,"label":"DC"},
    {"type":"DC","id":"dev12","x":944,"y":40,"label":"DC"},
    {"type":"RotaryEncoderBus","id":"dev13","x":1000,"y":24,"label":"OP"},
    {"type":"4bit7segBus","id":"dev14","x":1184,"y":24,"label":"4bit7segBus"},
    {"type":"DC","id":"dev15","x":632,"y":40,"label":"DC"},
    {"type":"RotaryEncoderBus","id":"dev16","x":384,"y":24,"label":"RB"},
    {"type":"Out","id":"dev17","x":368,"y":496,"label":"R2"},
    {"type":"Out","id":"dev18","x":368,"y":584,"label":"R3"},
    {"type":"4bit7segBus","id":"dev19","x":248,"y":24,"label":"4bit7segBus"},
    {"type":"Toggle","id":"dev20","x":56,"y":336,"label":"Toggle"},
    {"type":"DC","id":"dev21","x":24,"y":336,"label":"DC"},
    {"type":"PushOn","id":"dev22","x":56,"y":400,"label":"PushOn"},
    {"type":"DC","id":"dev23","x":24,"y":400,"label":"DC"},
    {"type":"RotaryEncoderBus","id":"dev24","x":680,"y":24,"label":"VALC"},
    {"type":"4<4","id":"dev25","x":1024,"y":320,"label":""},
    {"type":"4bit7segBus","id":"dev26","x":1104,"y":296,"label":"4bit7segBus"},
    {"type":"4>4","id":"dev27","x":1024,"y":192,"label":""},
    {"type":"4>4","id":"dev28","x":72,"y":192,"label":""},
    {"type":"4bit7segBus","id":"dev29","x":864,"y":24,"label":"4bit7segBus"},
    {"type":"REGISTER FILE","id":"dev30","x":232,"y":264,"label":"REGISTER FILE"},
    {"type":"4<4","id":"dev31","x":128,"y":280,"label":""},
    {"type":"4>4","id":"dev32","x":128,"y":224,"label":""},
    {"type":"4<4","id":"dev33","x":72,"y":264,"label":""},
    {"type":"Out","id":"dev34","x":368,"y":408,"label":"R1"},
    {"type":"4bit7segBus","id":"dev35","x":704,"y":208,"label":"4bit7segBus"},
    {"type":"4bit7segBus","id":"dev36","x":704,"y":392,"label":"4bit7segBus"},
    {"type":"ALU","id":"dev37","x":920,"y":296,"label":"ALU"},
    {"type":"4<4","id":"dev38","x":352,"y":288,"label":""},
    {"type":"4<4","id":"dev39","x":352,"y":304,"label":""},
    {"type":"4<4","id":"dev40","x":216,"y":144,"label":""},
    {"type":"4>4","id":"dev41","x":496,"y":224,"label":""},
    {"type":"4<4","id":"dev42","x":352,"y":272,"label":""},
    {"type":"4bit7segBus","id":"dev43","x":432,"y":392,"label":"4bit7segBus"},
    {"type":"4bit7segBus","id":"dev44","x":432,"y":480,"label":"4bit7segBus"},
    {"type":"4bit7segBus","id":"dev45","x":432,"y":568,"label":"4bit7segBus"},
    {"type":"Out","id":"dev46","x":1040,"y":656,"label":"PC"},
    {"type":"4bit7segBus","id":"dev47","x":1104,"y":640,"label":"4bit7segBus"},
    {"type":"pinleft","id":"dev48","x":216,"y":408,"label":""},
    {"type":"pinleft","id":"dev49","x":184,"y":296,"label":""},
    {"type":"pinleft","id":"dev50","x":168,"y":344,"label":""},
    {"type":"pinleft","id":"dev51","x":184,"y":640,"label":""},
    {"type":"pinleft","id":"dev52","x":232,"y":656,"label":""},
    {"type":"4>4","id":"dev53","x":1120,"y":128,"label":""},
    {"type":"4<4","id":"dev54","x":584,"y":144,"label":""},
    {"type":"NEWPC","id":"dev55","x":928,"y":640,"label":"NEWPC"},
    {"type":"4<4","id":"dev56","x":496,"y":352,"label":""},
    {"type":"4<4","id":"dev57","x":824,"y":344,"label":""},
    {"type":"4<4","id":"dev58","x":840,"y":672,"label":""},
    {"type":"4<4","id":"dev59","x":856,"y":296,"label":""},
    {"type":"4>4","id":"dev60","x":856,"y":128,"label":""},
    {"type":"4<4","id":"dev61","x":872,"y":688,"label":""}
  ],
  "connectors":[
    {"from":"dev0.in0","to":"dev20.out0"},
    {"from":"dev1.in0","to":"dev22.out0"},
    {"from":"dev2.in0","to":"dev13.out0"},
    {"from":"dev3.in0","to":"dev9.out0"},
    {"from":"dev4.in0","to":"dev16.out0"},
    {"from":"dev5.in0","to":"dev24.out0"},
    {"from":"dev6.in0","to":"dev54.out0"},
    {"from":"dev6.in2","to":"dev42.out0"},
    {"from":"dev6.in3","to":"dev38.out0"},
    {"from":"dev6.in4","to":"dev39.out0"},
    {"from":"dev7.in0","to":"dev4.out0"},
    {"from":"dev8.in0","to":"dev56.out0"},
    {"from":"dev8.in2","to":"dev30.out0"},
    {"from":"dev8.in3","to":"dev30.out1"},
    {"from":"dev8.in4","to":"dev30.out2"},
    {"from":"dev9.in0","to":"dev11.out0"},
    {"from":"dev13.in0","to":"dev12.out0"},
    {"from":"dev14.in0","to":"dev2.out0"},
    {"from":"dev16.in0","to":"dev10.out0"},
    {"from":"dev17.in0","to":"dev38.out0"},
    {"from":"dev18.in0","to":"dev39.out0"},
    {"from":"dev19.in0","to":"dev3.out0"},
    {"from":"dev20.in0","to":"dev21.out0"},
    {"from":"dev22.in0","to":"dev23.out0"},
    {"from":"dev24.in0","to":"dev15.out0"},
    {"from":"dev25.in0","to":"dev37.out0"},
    {"from":"dev26.in0","to":"dev25.out0"},
    {"from":"dev27.in0","to":"dev25.out0"},
    {"from":"dev28.in0","to":"dev27.out0"},
    {"from":"dev29.in0","to":"dev5.out0"},
    {"from":"dev30.in0","to":"dev33.out0"},
    {"from":"dev30.in1","to":"dev31.out0"},
    {"from":"dev30.in2","to":"dev49.out0"},
    {"from":"dev30.in3","to":"dev48.out0"},
    {"from":"dev31.in0","to":"dev32.out0"},
    {"from":"dev32.in0","to":"dev41.out0"},
    {"from":"dev33.in0","to":"dev28.out0"},
    {"from":"dev34.in0","to":"dev42.out0"},
    {"from":"dev35.in0","to":"dev6.out0"},
    {"from":"dev36.in0","to":"dev8.out0"},
    {"from":"dev37.in0","to":"dev59.out0"},
    {"from":"dev37.in1","to":"dev6.out0"},
    {"from":"dev37.in2","to":"dev8.out0"},
    {"from":"dev37.in3","to":"dev57.out0"},
    {"from":"dev38.in0","to":"dev30.out1"},
    {"from":"dev39.in0","to":"dev30.out2"},
    {"from":"dev40.in0","to":"dev3.out0"},
    {"from":"dev41.in0","to":"dev4.out0"},
    {"from":"dev42.in0","to":"dev30.out0"},
    {"from":"dev43.in0","to":"dev34.out0"},
    {"from":"dev44.in0","to":"dev17.out0"},
    {"from":"dev45.in0","to":"dev18.out0"},
    {"from":"dev46.in0","to":"dev55.out0"},
    {"from":"dev47.in0","to":"dev46.out0"},
    {"from":"dev48.in0","to":"dev1.out0"},
    {"from":"dev49.in0","to":"dev50.out0"},
    {"from":"dev50.in0","to":"dev0.out0"},
    {"from":"dev51.in0","to":"dev50.out0"},
    {"from":"dev52.in0","to":"dev48.out0"},
    {"from":"dev53.in0","to":"dev2.out0"},
    {"from":"dev54.in0","to":"dev40.out0"},
    {"from":"dev55.in0","to":"dev51.out0"},
    {"from":"dev55.in1","to":"dev52.out0"},
    {"from":"dev55.in2","to":"dev58.out0"},
    {"from":"dev55.in3","to":"dev61.out0"},
    {"from":"dev56.in0","to":"dev41.out0"},
    {"from":"dev57.in0","to":"dev5.out0"},
    {"from":"dev58.in0","to":"dev57.out0"},
    {"from":"dev59.in0","to":"dev60.out0"},
    {"from":"dev60.in0","to":"dev53.out0"},
    {"from":"dev61.in0","to":"dev59.out0"}
  ]
}
);		      

// EOF
